classification
Title: IDLE: document all key bindings, add menu items for more.
Type: behavior Stage: patch review
Components: IDLE Versions: Python 3.8, Python 3.7
process
Status: open Resolution:
Dependencies: Superseder:
Assigned To: terry.reedy Nosy List: cheryl.sabella, miss-islington, terry.reedy
Priority: normal Keywords: patch, patch, patch

Created on 2016-09-12 07:03 by terry.reedy, last changed 2018-12-28 20:29 by miss-islington.

Pull Requests
URL Status Linked Edit
PR 11325 merged cheryl.sabella, 2018-12-26 20:15
PR 11345 merged miss-islington, 2018-12-28 20:12
Messages (7)
msg275980 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2016-09-12 07:03
(Follow-up to #15308, which added ^C Interrupt Execution to doc and Shell menu, and to #27120, which proposed to add ^/ Toggle Highlighting, until I realized that that should be part of #6858, about highlighting non-.py files.)

Every IDLE function should be documented.  More should be on menu.  Perhaps add Move/delete menus for cursor movement and directional deletion, if not a diagram.

Another idea.  A searchable current key binding list, possible sortable by key as well as function.  It should include fixed builtin bindings as well as extension bindings.  See #27120 for motivation.

Side issue 1: Menu entries for extensions do not reflect customization (? verify, from Roger).

Side issue 2: Menus need to be tested.
msg278326 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2016-10-08 21:25
The toggle highlighting issue is #27170 (not 27120)
msg332560 - (view) Author: Cheryl Sabella (cheryl.sabella) * (Python committer) Date: 2018-12-26 20:18
PR11325 adds Previous/Next History to the Shell menu.
msg332641 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2018-12-28 04:17
Response to history issues raised in PR:
1. Not erasing output/history is a feature: some shells save and restore recent history when close and open.  Shell restart is an alternative to that.  I fairly often replay statements after restart.
2. I think turning off cycling is feature bloat.  (I never do so for search.)
3. The one history feature that multiple people have asked for, on another issue, is retrieval with up/down arrow, as seems to be standard.  I now agree.

For items going under edit, which is already 'full', submenus will be needed.  Since history is Shell only, separate entries are ok, at least for now, instead of 'History' and a submenu with 'previous' and 'next'.
msg332673 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2018-12-28 18:53
Cheryl, the addition looks nice.  But for anything else, lets discuss here first.
msg332678 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2018-12-28 20:11
New changeset c0381aaea4ad3e866bde70393c4f7efe9bcf3568 by Terry Jan Reedy (Cheryl Sabella) in branch 'master':
 bpo-28097: IDLE - Add Previous/Next History to Shell menu (#11325)
https://github.com/python/cpython/commit/c0381aaea4ad3e866bde70393c4f7efe9bcf3568
msg332679 - (view) Author: miss-islington (miss-islington) Date: 2018-12-28 20:29
New changeset b716c716b5d5dc630d85dd16ca6526948745c020 by Miss Islington (bot) in branch '3.7':
bpo-28097: IDLE - Add Previous/Next History to Shell menu (GH-11325)
https://github.com/python/cpython/commit/b716c716b5d5dc630d85dd16ca6526948745c020
History
Date User Action Args
2018-12-28 20:29:46miss-islingtonsetnosy: + miss-islington
messages: + msg332679
2018-12-28 20:15:10terry.reedysetpull_requests: - pull_request10637
2018-12-28 20:14:57terry.reedysetpull_requests: - pull_request10638
2018-12-28 20:12:17miss-islingtonsetstage: needs patch -> patch review
pull_requests: + pull_request10638
2018-12-28 20:12:13miss-islingtonsetstage: needs patch -> needs patch
pull_requests: + pull_request10637
2018-12-28 20:12:08miss-islingtonsetstage: needs patch -> needs patch
pull_requests: + pull_request10636
2018-12-28 20:11:33terry.reedysetmessages: + msg332678
2018-12-28 18:53:13terry.reedysetkeywords: patch, patch, patch

messages: + msg332673
2018-12-28 04:17:43terry.reedysetkeywords: patch, patch, patch

messages: + msg332641
2018-12-28 03:27:31terry.reedysetpull_requests: - pull_request10589
2018-12-28 03:27:18terry.reedysetpull_requests: - pull_request10590
2018-12-28 01:53:12terry.reedysetkeywords: patch, patch, patch
versions: + Python 3.7, Python 3.8, - Python 3.6
2018-12-26 20:18:06cheryl.sabellasetnosy: + cheryl.sabella

messages: + msg332560
stage: patch review -> needs patch
2018-12-26 20:15:52cheryl.sabellasetkeywords: + patch
stage: needs patch -> patch review
pull_requests: + pull_request10590
2018-12-26 20:15:49cheryl.sabellasetkeywords: + patch
stage: needs patch -> needs patch
pull_requests: + pull_request10589
2018-12-26 20:15:46cheryl.sabellasetkeywords: + patch
stage: needs patch -> needs patch
pull_requests: + pull_request10588
2016-10-08 21:30:25terry.reedylinkissue27170 superseder
2016-10-08 21:25:39terry.reedysetmessages: + msg278326
2016-09-12 07:03:30terry.reedycreate